// LoadTileset.cpp : implementation file
//

#include "stdafx.h"
#include "MapEditor.h"
#include "LoadTileset.h"
#include "metalwar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int find_texture_from_name_UFS(char filename[]);
void draw_poly(VERTEX *A1a, TEXCOORD *T1, VERTEX *A2a, TEXCOORD *T2, VERTEX *A3a, TEXCOORD *T3,int b);


/////////////////////////////////////////////////////////////////////////////
// LoadTileset dialog


LoadTileset::LoadTileset(CWnd* pParent /*=NULL*/)
	: CDialog(LoadTileset::IDD, pParent)
{
	//{{AFX_DATA_INIT(LoadTileset)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void LoadTileset::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LoadTileset)
	DDX_Control(pDX, LISTtilesets, m_LISTtilesets);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(LoadTileset, CDialog)
	//{{AFX_MSG_MAP(LoadTileset)
	ON_BN_CLICKED(BTloadTileset, OnBTloadTileset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//###############################################################################################################################################################
// LoadTileset message handlers

BOOL LoadTileset::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	

	int numFound = SearchDirectory("c:/Metalwar/gamedata/Tilesets/*.*");

	for (int ctile=0;ctile<numFound;ctile++){
		
		if (game.resources.c_file[ctile].attrib == _A_SUBDIR && game.resources.c_file[ctile].name[0] != '.'){
		
			this->m_LISTtilesets.AddString(game.resources.c_file[ctile].name);

		}
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


//###############################################################################################################################################################

void LoadTileset::OnBTloadTileset() 
{
	// TODO: Add your control notification handler code here



	char tilesetFilename[256];
	this->m_LISTtilesets.GetText(this->m_LISTtilesets.GetCurSel(), tilesetFilename);


	game.resources.tileset.load(tilesetFilename);

	this->EndDialog(1);
}


//###############################################################################################################################################################
// load() - loads a tileset from the disk...

void TILESET::load(char filename[]){

//load all textures associated with this tileset...
	game.resources.textures.clearTerrainTextures();
	game.resources.textures.loadTerrainTextures(filename);

	this->minz = 1000000.0;
	this->maxz = -1000000.0;

	game.mainDialog->m_LISTconsole.AddString(filename);

	char tilesetPath[256];
	sprintf(tilesetPath, "c:/metalwar/gamedata/tilesets/%s/*.ase", filename);

	sprintf(this->filename, filename);

//clear the tileset toolbar...
	game.mainDialog->m_LISTtileset.ResetContent();

	this->numTiles = SearchDirectory(tilesetPath);

	char feedbackText[256] = "";

//loop through all found tiles, and load them...
	for (int ctile = 0; ctile < this->numTiles; ctile ++){
		sprintf(feedbackText, "[%d] Loaded tile : %s", game.resources.tileset.numTiles,game.resources.c_file[ctile].name);
		game.mainDialog->m_LISTconsole.AddString(feedbackText);

//load the tile from disk...
		char tileFilename[256];
		sprintf(tileFilename, "c:/metalwar/gamedata/tilesets/%s/%s", filename, game.resources.c_file[ctile].name);
		
		char tempTileName[128];
		sprintf(tempTileName, ">>%s", game.resources.c_file[ctile].name);

		//game.mainDialog->m_LISTtileset.AddString(game.resources.c_file[ctile].name);
		game.mainDialog->m_LISTtileset.InsertString(ctile, tempTileName);

		game.resources.tileset.tile[ctile] = new TILE(tileFilename);
		sprintf(game.resources.tileset.tile[ctile]->filename, game.resources.c_file[ctile].name);

	}


//clear the features toolbar...
	game.mainDialog->m_LISTfeatures.ResetContent();

	char tilesetFeaturesPath[256];
	sprintf(tilesetFeaturesPath, "c:/metalwar/gamedata/tilesets/%s/features/*.ase", filename);

	this->numFeatures = SearchDirectory(tilesetFeaturesPath);
	
//loop through all found tiles, and load them...
	for (int cfeature = 0; cfeature < this->numFeatures; cfeature ++){
		sprintf(feedbackText, "[%d] Loaded feature : %s", game.resources.tileset.numFeatures,game.resources.c_file[cfeature].name);
		game.mainDialog->m_LISTconsole.AddString(feedbackText);

//load the tile from disk...
		char featureFilename[256];
		sprintf(featureFilename, "c:/metalwar/gamedata/tilesets/%s/features/%s", filename, game.resources.c_file[cfeature].name);
		
		char tempFeatureName[128];
		sprintf(tempFeatureName, ">>%s", game.resources.c_file[cfeature].name);

		//game.mainDialog->m_LISTtileset.AddString(game.resources.c_file[ctile].name);
		game.mainDialog->m_LISTfeatures.InsertString(cfeature, tempFeatureName);

		game.resources.tileset.feature[cfeature] = new FEATURE(featureFilename);
		sprintf(game.resources.tileset.feature[cfeature]->filename, game.resources.c_file[cfeature].name);
	}



	game.mainDialog->m_LISTconsole.AddString("Tileset loaded OK...");

}



//###############################################################################################################################################################
// TILE constructor...

TILE::TILE(char filename[]){

	FILE *h;
	char total_filename[256];

	int numMats = 0;

	game.resources.materials.num_materials = 0;

	int currentAnim = 0;
	char totalString[256];

	game.resources.materials.num_materials = 0;
	for (int cmat=0;cmat<25;cmat++){
		game.resources.materials.material[cmat].num_materials = 0;
		for (int smat=0;smat<25;smat++){
			game.resources.materials.material[cmat].subMaterial[smat].texture = NULL;
		}
	}

		
		h = fopen(filename, "ra");

//if it does not exist, then it is to be interpolated at run-time, so tell the game this, and skip...
		if (h == NULL) {
//go on to the next frame...
			return;
		}

		
		this->num_polys = this->num_verts = 0;

		char temp[256];
		
		int current_object = 0;
		int currentMaterial = 0;
		int currentSubMaterial = 0;
		float ticksPerFrame = 0.0;



		float left = 0.0,right = 0.0,back = 0.0,front = 0.0;


		do {

			fscanf(h, "%s", temp);

			if (!strcmp("*SCENE", temp)){
				fscanf(h, "%s", temp);

				do{
					fscanf(h, "%s", temp);

					if (!strcmp("*SCENE_TICKSPERFRAME", temp)){
						fscanf(h, "%s", temp);
						ticksPerFrame = atof(temp);
					}

					if (!strcmp("}", temp)) break;		
				} while(1);
				continue;
			}

			if (!strcmp("*MATERIAL_LIST", temp)){
				fscanf(h, "%s", temp);


				do{
					fscanf(h, "%s", temp);

					if (!strcmp("*MATERIAL", temp)){
//reset sub-materials present flag...						
						int subMaterials = 0;

						game.resources.materials.num_materials = 0;

						fscanf(h, "%s", temp);

//set the current material number...						
						currentMaterial = atoi(temp);

						fscanf(h, "%s", temp);

						do{
							fscanf(h, "%s", temp);
		
//if this material has sub-materials...
							if (!strcmp("*NUMSUBMTLS", temp)){
								subMaterials = 1;
							}

//if this is not a sub-material...
							if (!subMaterials){
								if (!strcmp("*MAP_DIFFUSE", temp)){

									fscanf(h, "%s", temp);

									do{
										fscanf(h, "%s", temp);

										if (!strcmp("*BITMAP", temp)){
											fscanf(h, "%s", temp);
											game.resources.materials.material[currentMaterial].subMaterial[0].texture = find_texture_from_name_UFS(temp);

										}

										if (!strcmp("}", temp)) break;		
									} while(1);
									continue;
								}
								
								if (!strcmp("}", temp)) {
									break;		
								}
							} else {
//if we have found a sub-material...
								if (!strcmp("*SUBMATERIAL", temp)){

									int foundBitmap = 0;
									fscanf(h, "%s", temp);
//set current sub-material...
									currentSubMaterial = atoi(temp);
//loop...
									do{
										fscanf(h, "%s", temp);

//if we have found a map...
										if (!strcmp("*MAP_DIFFUSE", temp)){
											foundBitmap = 1;
											fscanf(h, "%s", temp);

											do{
												fscanf(h, "%s", temp);

												if (!strcmp("*BITMAP", temp)){
													fscanf(h, "%s", temp);
													game.resources.materials.material[currentMaterial].subMaterial[currentSubMaterial].texture = find_texture_from_name_UFS(temp);
												}

												if (!strcmp("}", temp)) {
													break;		
												}
											} while(1);
											continue;
										}

										if (!strcmp("}", temp)) break;		
									} while(1);
									continue;
									

								}
							}


							if (!strcmp("}", temp)) break;		
						} while(1);
					
						game.resources.materials.material[currentMaterial].num_materials = currentSubMaterial + 1;
						
						continue;
					}

					if (!strcmp("}", temp)) break;		
				} while(1);

				game.resources.materials.num_materials = currentMaterial + 1;

				continue;
			}



			if (!strcmp("*GEOMOBJECT", temp)){

				fscanf(h, "%s", temp);

				do{
					fscanf(h, "%s", temp);

//extract the name of this object...
					if (!strcmp("*NODE_NAME", temp)) {
						fscanf(h, "%s", temp);

					}

					if (!strcmp("*NODE_TM", temp)) {
						fscanf(h, "%s", temp);
						do{
							fscanf(h, "%s", temp);

						
							if (!strcmp("}", temp)) break;		
						} while(1);
						continue;
					}

					if (!strcmp("*MESH", temp)) {
						fscanf(h, "%s", temp);
						
						do{
							fscanf(h, "%s", temp);

								
							if (!strcmp("*MESH_NUMVERTEX", temp)) {

								fscanf(h, "%s", temp);
								this->num_verts = atoi(temp);
								this->vertex = (VERTEX *) malloc( sizeof(VERTEX) * atoi(temp) );
							}

							if (!strcmp("*MESH_NUMFACES", temp)) {
								fscanf(h, "%s", temp);
								this->num_polys = atoi(temp);
								this->poly = (POLY *) malloc(sizeof(POLY) * atoi(temp));
							}
							
							if (!strcmp("*MESH_NUMTVERTEX", temp)) {
								fscanf(h, "%s", temp);
								this->num_texcoords = atoi(temp);
								this->texcoord = (TEXCOORD *) malloc(sizeof(TEXCOORD) * atoi(temp));
							}

							if (!strcmp("*MESH_VERTEX_LIST", temp)) {
								fscanf(h, "%s", temp);

								int current_vertex;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_VERTEX", temp)) {
										fscanf(h, "%s", temp);

										current_vertex = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->vertex[current_vertex].x = atof(temp);

										if (this->vertex[current_vertex].x > right) right = this->vertex[current_vertex].x;
										if (this->vertex[current_vertex].x < left) left = this->vertex[current_vertex].x;

										fscanf(h, "%s", temp);
										this->vertex[current_vertex].y = atof(temp);

										if (this->vertex[current_vertex].y > front) front = this->vertex[current_vertex].y;
										if (this->vertex[current_vertex].y < back) back = this->vertex[current_vertex].y;

										fscanf(h, "%s", temp);
										this->vertex[current_vertex].z = atof(temp);


										if (this->vertex[current_vertex].z > game.resources.tileset.maxz) game.resources.tileset.maxz = this->vertex[current_vertex].z;
										if (this->vertex[current_vertex].z < game.resources.tileset.minz) game.resources.tileset.minz = this->vertex[current_vertex].z;


										this->vertex[current_vertex].r = 255;
										this->vertex[current_vertex].g = 255;
										this->vertex[current_vertex].b = 255;
									}

									if (!strcmp("}", temp)) break;
								} while(1);
								continue;
							}
							if (!strcmp("*MESH_FACE_LIST", temp)) {
								fscanf(h, "%s", temp);

								int current_face;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_FACE", temp)) {
										fscanf(h, "%s", temp);
										current_face = atoi(temp);

										do{
											fscanf(h, "%s", temp);

											if (!strcmp("A:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[2] = atoi(temp);
											}

											if (!strcmp("B:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[1] = atoi(temp);
											}

											if (!strcmp("C:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[0] = atoi(temp);	
											}


											if (!strcmp("*MESH_MTLID", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].SUBMATERIAL_NUM = atoi(temp);

												break;
											}

										}while(1);
										continue;
									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}
							if (!strcmp("*MESH_TVERTLIST", temp)) {
								fscanf(h, "%s", temp);

								int current_tvert;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_TVERT", temp)) {
										fscanf(h, "%s", temp);

										current_tvert = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->texcoord[current_tvert].u = atof(temp);
										fscanf(h, "%s", temp);
										this->texcoord[current_tvert].v = atof(temp);
										fscanf(h, "%s", temp);
									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}

							if (!strcmp("*MESH_TFACELIST", temp)) {
								fscanf(h, "%s", temp);
								do{
									fscanf(h, "%s", temp);

									int current_tface;

									if (!strcmp("*MESH_TFACE", temp)) {
										fscanf(h, "%s", temp);

										current_tface = atoi(temp);

										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[2] = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[1] = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[0] = atoi(temp);

									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}
		
							if (!strcmp("}", temp)) break;
						} while(1);
						continue;					
					}

					if (!strcmp("*MATERIAL_REF", temp)) {
						int a;
						fscanf(h, "%s", temp);

//set the current material reference...
						int materialRef = atoi(temp);
						if (materialRef >= game.resources.materials.num_materials) materialRef = game.resources.materials.num_materials - 1;

						for (a=0;a<this->num_polys;a++){
					
//set the texture ID...
							if (this->poly[a].SUBMATERIAL_NUM >= game.resources.materials.material[materialRef].num_materials){
								this->poly[a].SUBMATERIAL_NUM = game.resources.materials.material[materialRef].num_materials - 1;
							}
							this->poly[a].texture_id = game.resources.materials.material[materialRef].subMaterial[this->poly[a].SUBMATERIAL_NUM].texture;

						}
					}

					if (!strcmp("}", temp)) break;
					
				} while(1);

				current_object++;
				continue;
			}



			if (!strcmp("}", temp)) break;

		} while(1);
	
		this->waterHeight = -1000.0;

		for (int cpoly=0; cpoly < this->num_polys; cpoly++){
			this->poly[cpoly].isWater = 0;
		
			this->poly[cpoly].left = 10000;
			this->poly[cpoly].right = -10000;
			this->poly[cpoly].back = 10000;
			this->poly[cpoly].front = -10000;
			
			for (int cvert=0; cvert < 3; cvert++){
//find bounds of polygons...
				if (this->vertex[this->poly[cpoly].vtx[cvert]].x < this->poly[cpoly].left) this->poly[cpoly].left = this->vertex[this->poly[cpoly].vtx[cvert]].x;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].x > this->poly[cpoly].right) this->poly[cpoly].right = this->vertex[this->poly[cpoly].vtx[cvert]].x;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].y < this->poly[cpoly].back) this->poly[cpoly].back = this->vertex[this->poly[cpoly].vtx[cvert]].y;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].y > this->poly[cpoly].front) this->poly[cpoly].front = this->vertex[this->poly[cpoly].vtx[cvert]].y;
			
			}
//if this polygon is water, then set the water height...
			if (!strcmp(game.resources.textures.terrain_textures[this->poly[cpoly].texture_id].name, "water.tga")){
				if (this->waterHeight == -1000.0 ) {
					this->waterHeight = this->vertex[this->poly[cpoly].vtx[0]].z;
				}
				this->poly[cpoly].isWater = 1;
			}
		}

		/*char fbt[128];
		sprintf(fbt, "WaterHeight: %d", this->waterHeight);
		game.mainDialog->m_LISTconsole.AddString(fbt);*/

		this->gsx = (right-left) / 20.0;
		this->gsy = (front-back) / 20.0;

		this->findHeights();

		this->light();
}



//###############################################################################################################################################################
// FEATURE constructor...

FEATURE::FEATURE(char filename[]){

	FILE *h;
	char total_filename[256];

	int numMats = 0;

	game.resources.materials.num_materials = 0;

	int currentAnim = 0;
	char totalString[256];

	game.resources.materials.num_materials = 0;
	for (int cmat=0;cmat<25;cmat++){
		game.resources.materials.material[cmat].num_materials = 0;
		for (int smat=0;smat<25;smat++){
			game.resources.materials.material[cmat].subMaterial[smat].texture = NULL;
		}
	}


		h = fopen(filename, "ra");

//if it does not exist, then it is to be interpolated at run-time, so tell the game this, and skip...
		if (h == NULL) {
//go on to the next frame...
			return;
		}

		
		this->num_polys = this->num_verts = 0;

		char temp[256];
		
		int current_object = 0;
		int currentMaterial = 0;
		int currentSubMaterial = 0;
		float ticksPerFrame = 0.0;



		float left = 0.0,right = 0.0,back = 0.0,front = 0.0;


		do {

			fscanf(h, "%s", temp);

			if (!strcmp("*SCENE", temp)){
				fscanf(h, "%s", temp);

				do{
					fscanf(h, "%s", temp);

					if (!strcmp("*SCENE_TICKSPERFRAME", temp)){
						fscanf(h, "%s", temp);
						ticksPerFrame = atof(temp);
					}

					if (!strcmp("}", temp)) break;		
				} while(1);
				continue;
			}

			if (!strcmp("*MATERIAL_LIST", temp)){
				fscanf(h, "%s", temp);


				do{
					fscanf(h, "%s", temp);

					if (!strcmp("*MATERIAL", temp)){
//reset sub-materials present flag...						
						int subMaterials = 0;

						game.resources.materials.num_materials = 0;

						fscanf(h, "%s", temp);

//set the current material number...						
						currentMaterial = atoi(temp);

						fscanf(h, "%s", temp);

						do{
							fscanf(h, "%s", temp);
		
//if this material has sub-materials...
							if (!strcmp("*NUMSUBMTLS", temp)){
								subMaterials = 1;
							}

//if this is not a sub-material...
							if (!subMaterials){
								if (!strcmp("*MAP_DIFFUSE", temp)){

									fscanf(h, "%s", temp);

									do{
										fscanf(h, "%s", temp);

										if (!strcmp("*BITMAP", temp)){
											fscanf(h, "%s", temp);
											game.resources.materials.material[currentMaterial].subMaterial[0].texture = find_texture_from_name_UFS(temp);

										}

										if (!strcmp("}", temp)) break;		
									} while(1);
									continue;
								}
								
								if (!strcmp("}", temp)) {
									break;		
								}
							} else {
//if we have found a sub-material...
								if (!strcmp("*SUBMATERIAL", temp)){

									int foundBitmap = 0;
									fscanf(h, "%s", temp);
//set current sub-material...
									currentSubMaterial = atoi(temp);
//loop...
									do{
										fscanf(h, "%s", temp);

//if we have found a map...
										if (!strcmp("*MAP_DIFFUSE", temp)){
											foundBitmap = 1;
											fscanf(h, "%s", temp);

											do{
												fscanf(h, "%s", temp);

												if (!strcmp("*BITMAP", temp)){
													fscanf(h, "%s", temp);
													game.resources.materials.material[currentMaterial].subMaterial[currentSubMaterial].texture = find_texture_from_name_UFS(temp);
												}

												if (!strcmp("}", temp)) {
													break;		
												}
											} while(1);
											continue;
										}

										if (!strcmp("}", temp)) break;		
									} while(1);
									continue;
									

								}
							}


							if (!strcmp("}", temp)) break;		
						} while(1);
					
						game.resources.materials.material[currentMaterial].num_materials = currentSubMaterial + 1;
						
						continue;
					}

					if (!strcmp("}", temp)) break;		
				} while(1);

				game.resources.materials.num_materials = currentMaterial + 1;

				continue;
			}



			if (!strcmp("*GEOMOBJECT", temp)){

				fscanf(h, "%s", temp);

				do{
					fscanf(h, "%s", temp);

//extract the name of this object...
					if (!strcmp("*NODE_NAME", temp)) {
						fscanf(h, "%s", temp);

					}

					if (!strcmp("*NODE_TM", temp)) {
						fscanf(h, "%s", temp);
						do{
							fscanf(h, "%s", temp);

						
							if (!strcmp("}", temp)) break;		
						} while(1);
						continue;
					}

					if (!strcmp("*MESH", temp)) {
						fscanf(h, "%s", temp);
						
						do{
							fscanf(h, "%s", temp);

								
							if (!strcmp("*MESH_NUMVERTEX", temp)) {

								fscanf(h, "%s", temp);
								this->num_verts = atoi(temp);
								this->vertex = (VERTEX *) malloc( sizeof(VERTEX) * atoi(temp) );
							}

							if (!strcmp("*MESH_NUMFACES", temp)) {
								fscanf(h, "%s", temp);
								this->num_polys = atoi(temp);
								this->poly = (POLY *) malloc(sizeof(POLY) * atoi(temp));
							}
							
							if (!strcmp("*MESH_NUMTVERTEX", temp)) {
								fscanf(h, "%s", temp);
								this->num_texcoords = atoi(temp);
								this->texcoord = (TEXCOORD *) malloc(sizeof(TEXCOORD) * atoi(temp));
							}

							if (!strcmp("*MESH_VERTEX_LIST", temp)) {
								fscanf(h, "%s", temp);

								int current_vertex;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_VERTEX", temp)) {
										fscanf(h, "%s", temp);

										current_vertex = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->vertex[current_vertex].x = atof(temp);

										if (this->vertex[current_vertex].x > right) right = this->vertex[current_vertex].x;
										if (this->vertex[current_vertex].x < left) left = this->vertex[current_vertex].x;

										fscanf(h, "%s", temp);
										this->vertex[current_vertex].y = atof(temp);

										if (this->vertex[current_vertex].y > front) front = this->vertex[current_vertex].y;
										if (this->vertex[current_vertex].y < back) back = this->vertex[current_vertex].y;

										fscanf(h, "%s", temp);
										this->vertex[current_vertex].z = atof(temp);

										this->vertex[current_vertex].r = 255;
										this->vertex[current_vertex].g = 255;
										this->vertex[current_vertex].b = 255;
									}

									if (!strcmp("}", temp)) break;
								} while(1);
								continue;
							}
							if (!strcmp("*MESH_FACE_LIST", temp)) {
								fscanf(h, "%s", temp);

								int current_face;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_FACE", temp)) {
										fscanf(h, "%s", temp);
										current_face = atoi(temp);

										do{
											fscanf(h, "%s", temp);

											if (!strcmp("A:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[2] = atoi(temp);
											}

											if (!strcmp("B:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[1] = atoi(temp);
											}

											if (!strcmp("C:", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].vtx[0] = atoi(temp);	
											}


											if (!strcmp("*MESH_MTLID", temp)) {
												fscanf(h, "%s", temp);

												this->poly[current_face].SUBMATERIAL_NUM = atoi(temp);

												break;
											}

										}while(1);
										continue;
									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}
							if (!strcmp("*MESH_TVERTLIST", temp)) {
								fscanf(h, "%s", temp);

								int current_tvert;

								do{
									fscanf(h, "%s", temp);

									if (!strcmp("*MESH_TVERT", temp)) {
										fscanf(h, "%s", temp);

										current_tvert = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->texcoord[current_tvert].u = atof(temp);
										fscanf(h, "%s", temp);
										this->texcoord[current_tvert].v = atof(temp);
										fscanf(h, "%s", temp);
									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}

							if (!strcmp("*MESH_TFACELIST", temp)) {
								fscanf(h, "%s", temp);
								do{
									fscanf(h, "%s", temp);

									int current_tface;

									if (!strcmp("*MESH_TFACE", temp)) {
										fscanf(h, "%s", temp);

										current_tface = atoi(temp);

										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[2] = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[1] = atoi(temp);
										
										fscanf(h, "%s", temp);
										this->poly[current_tface].tex[0] = atoi(temp);

									}

									if (!strcmp("}", temp)) break;				
								} while(1);
								continue;
							}
		
							if (!strcmp("}", temp)) break;
						} while(1);
						continue;					
					}

					if (!strcmp("*MATERIAL_REF", temp)) {
						int a;
						fscanf(h, "%s", temp);

//set the current material reference...
						int materialRef = atoi(temp);
						if (materialRef >= game.resources.materials.num_materials) materialRef = game.resources.materials.num_materials - 1;

						for (a=0;a<this->num_polys;a++){
					
//set the texture ID...
							if (this->poly[a].SUBMATERIAL_NUM >= game.resources.materials.material[materialRef].num_materials){
								this->poly[a].SUBMATERIAL_NUM = game.resources.materials.material[materialRef].num_materials - 1;
							}
							this->poly[a].texture_id = game.resources.materials.material[materialRef].subMaterial[this->poly[a].SUBMATERIAL_NUM].texture;

						}
					}

					if (!strcmp("}", temp)) break;
					
				} while(1);

				current_object++;
				continue;
			}



			if (!strcmp("}", temp)) break;

		} while(1);
	

		for (int cpoly=0; cpoly < this->num_polys; cpoly++){
			this->poly[cpoly].isWater = 0;
		
			this->poly[cpoly].left = 10000;
			this->poly[cpoly].right = -10000;
			this->poly[cpoly].back = 10000;
			this->poly[cpoly].front = -10000;
			
			for (int cvert=0; cvert < 3; cvert++){
//find bounds of polygons...
				if (this->vertex[this->poly[cpoly].vtx[cvert]].x < this->poly[cpoly].left) this->poly[cpoly].left = this->vertex[this->poly[cpoly].vtx[cvert]].x;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].x > this->poly[cpoly].right) this->poly[cpoly].right = this->vertex[this->poly[cpoly].vtx[cvert]].x;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].y < this->poly[cpoly].back) this->poly[cpoly].back = this->vertex[this->poly[cpoly].vtx[cvert]].y;
				if (this->vertex[this->poly[cpoly].vtx[cvert]].y > this->poly[cpoly].front) this->poly[cpoly].front = this->vertex[this->poly[cpoly].vtx[cvert]].y;
			
			}
		}

		this->gsx = ((right-left) / 20.0)+2;
		this->gsy = ((front-back) / 20.0)+2;

		this->findFilled();

		this->light();
}



//###############################################################################################################################################################
//findFilled() - finds all filled squares for this feature...

void FEATURE::findFilled(void){

	for (int cvertex=0; cvertex < this->num_verts; cvertex++){


		if (this->vertex[cvertex].z < 10.0){

			this->canMoves[(int)((this->vertex[cvertex].x / 20.0) + (this->gsx / 2.0))][(int)((this->vertex[cvertex].x / 20.0) + (this->gsy / 2.0))] = 1;
		
		}


	}

}

//###############################################################################################################################################################


int find_texture_from_name_UFS(char filename[]){
	
	char f_filename[256] = " ";
	char ff_filename[256] = " ";
	char fff_filename[256] = " ";
	int a = 0;
	int pp,last_slash_point;
	
	char fp_filename[256] = " ";
	
	for (a =0; a< strlen(filename) - 2;a++){
		f_filename[a] = filename[a+1];
	}
	
	a = 0;

	int last_slash, lastlast_slash, this_slash;

	lastlast_slash = last_slash = this_slash = 0;

	do {

		if (f_filename[a] == 92) {
			lastlast_slash = last_slash;
			last_slash = this_slash;
			this_slash = a;
		}

		a++;
	} while(a < strlen(f_filename));


	for (a=this_slash+1; a < strlen(f_filename); a++){
		
		ff_filename[a-this_slash-1] = f_filename[a];

	}

	a=0;	
	do{
		
		if (game.resources.textures.terrain_textures[a].loaded_ok){
			if (!_stricmp(ff_filename, game.resources.textures.terrain_textures[a].name)){
				return a;
			}
		}
					
		a++;

	} while(a<game.resources.textures.num_terrain_textures);
	

//if not found, then set to the player's color texture (-1)...	
	return -1;
}


//###############################################################################################################################################################


void TILE::findHeights(void){
	int a,collision=0;
	
	VERTEX *v1,*v2,*v3;
	
	for (int cgridx=0; cgridx < this->gsx+1; cgridx++){
		for (int cgridy=0; cgridy < this->gsy+1; cgridy++){
			
			this->height[cgridx][cgridy] = 0.0;

			float xpos = (cgridx*20.0) - (this->gsx*10.0);
			float ypos = (cgridy*20.0) - (this->gsy*10.0);

			for (int cpoly=0;cpoly<this->num_polys;cpoly++){
				
				if (xpos > this->poly[cpoly].left - 2 && xpos < this->poly[cpoly].right + 2
					&& ypos > this->poly[cpoly].back - 2 && ypos < this->poly[cpoly].front + 2){
				
					v1 = &this->vertex[this->poly[cpoly].vtx[0]];
					v2 = &this->vertex[this->poly[cpoly].vtx[1]];
					v3 = &this->vertex[this->poly[cpoly].vtx[2]];
								
					VECTOR	Edge1, Edge2;
					VECTOR	t_Normal;
					VECTOR	t_Origin;
					t_Origin.set(xpos,ypos,v1->z - 1000.0f);
					VECTOR  t_PlaneDist1;
					t_PlaneDist1.set(v1->x, v1->y, v1->z);
								
					Edge1.set(v2->x-v1->x, v2->y-v1->y, v2->z-v1->z);
					Edge2.set(v3->x-v1->x, v3->y-v1->y, v3->z-v1->z);
								
					t_Normal = CrossProduct(Edge1,Edge2);
					t_Normal.MakeUnit();
								
					float t_PlaneDist2 = DotProduct( t_PlaneDist1, t_Normal);
								
								
								
					VECTOR    t_Vector;
					t_Vector.set( 0.0f, 0.0f, 1.0f );
								
					float t = distRayPlane( t_Origin, t_Vector, t_Normal, t_PlaneDist2);
								
					if (t>0){
									
									//Calculate the intersection point with the plane
						VECTOR IP;
						IP.set ( t_Origin.x + (t_Vector.x * t),t_Origin.y + (t_Vector.y * t),t_Origin.z + (t_Vector.z * t) );
									
									// Is the intersection point within the triangle ?
						VECTOR t_va,t_vb,t_vc;

						t_va.set(v1->x,v1->y,v1->z);
						t_vb.set(v2->x,v2->y,v2->z);
						t_vc.set(v3->x,v3->y,v3->z);
						
						//if (VertexInTriangle(IP, t_va, t_vb, t_vc) == true){
							this->height[cgridx][cgridy] = IP.z;
							if (this->height[cgridx][cgridy] < this->waterHeight) this->height[cgridx][cgridy] = this->waterHeight;
						//}

						cpoly = 1000000;
					}

				}
			}
		}
	}
}


//###############################################################################################################################################################


void TILE::light(void){

	for (int cpoly=0;cpoly<this->num_polys;cpoly++){
	
		VECTOR Edge1, Edge2;
		float t_Shade;
		VECTOR   t_Normal;
		float AmbientLight = 0.3;

		Edge1.set(this->vertex[this->poly[cpoly].vtx[1]].x-this->vertex[this->poly[cpoly].vtx[0]].x, this->vertex[this->poly[cpoly].vtx[1]].y-this->vertex[this->poly[cpoly].vtx[0]].y, (this->vertex[this->poly[cpoly].vtx[1]].z-this->vertex[this->poly[cpoly].vtx[0]].z)*1.0);
		Edge2.set(this->vertex[this->poly[cpoly].vtx[2]].x-this->vertex[this->poly[cpoly].vtx[0]].x, this->vertex[this->poly[cpoly].vtx[2]].y-this->vertex[this->poly[cpoly].vtx[0]].y, (this->vertex[this->poly[cpoly].vtx[2]].z-this->vertex[this->poly[cpoly].vtx[0]].z)*1.0);
		
		t_Normal = MWCrossProduct(&Edge1, &Edge2);
		t_Normal.MakeUnit();
		
		//*** Cosine shading based on the surface normal, clamped to [0, 1]
		float Shade = MWDotProduct(&t_Normal, &game.display.light_source_direction);
		
		if (Shade < 0) Shade = 0;
		
		Shade = Shade + AmbientLight;
		
		if (Shade > 1.0) Shade = 1.0;

		t_Shade = Shade;

		this->vertex[this->poly[cpoly].vtx[0]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[0]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[0]].b = 255.0f*t_Shade;

		this->vertex[this->poly[cpoly].vtx[1]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[1]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[1]].b = 255.0f*t_Shade;

		this->vertex[this->poly[cpoly].vtx[2]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[2]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[2]].b = 255.0f*t_Shade;

	}
}


//###############################################################################################################################################################


void FEATURE::light(void){

	for (int cpoly=0;cpoly<this->num_polys;cpoly++){
	
		VECTOR Edge1, Edge2;
		float t_Shade;
		VECTOR   t_Normal;
		float AmbientLight = 0.3;

		Edge1.set(this->vertex[this->poly[cpoly].vtx[1]].x-this->vertex[this->poly[cpoly].vtx[0]].x, this->vertex[this->poly[cpoly].vtx[1]].y-this->vertex[this->poly[cpoly].vtx[0]].y, (this->vertex[this->poly[cpoly].vtx[1]].z-this->vertex[this->poly[cpoly].vtx[0]].z)*1.0);
		Edge2.set(this->vertex[this->poly[cpoly].vtx[2]].x-this->vertex[this->poly[cpoly].vtx[0]].x, this->vertex[this->poly[cpoly].vtx[2]].y-this->vertex[this->poly[cpoly].vtx[0]].y, (this->vertex[this->poly[cpoly].vtx[2]].z-this->vertex[this->poly[cpoly].vtx[0]].z)*1.0);
		
		t_Normal = MWCrossProduct(&Edge1, &Edge2);
		t_Normal.MakeUnit();
		
		//*** Cosine shading based on the surface normal, clamped to [0, 1]
		float Shade = MWDotProduct(&t_Normal, &game.display.light_source_direction);
		
		if (Shade < 0) Shade = 0;
		
		Shade = Shade + AmbientLight;
		
		if (Shade > 1.0) Shade = 1.0;

		t_Shade = Shade;

		this->vertex[this->poly[cpoly].vtx[0]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[0]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[0]].b = 255.0f*t_Shade;

		this->vertex[this->poly[cpoly].vtx[1]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[1]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[1]].b = 255.0f*t_Shade;

		this->vertex[this->poly[cpoly].vtx[2]].r = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[2]].g = 255.0f*t_Shade;
		this->vertex[this->poly[cpoly].vtx[2]].b = 255.0f*t_Shade;

	}
}

//###############################################################################################################################################################


void TILESET::clearMemory(void){

	for (int ctile=0;ctile<this->numTiles;ctile++){

		this->tile[ctile]->clear();
		this->tile[ctile] = NULL;

	}

	this->numTiles = 0;

}


//###############################################################################################################################################################


void TILE::clear(void){

	free(this->poly);
	free(this->vertex);
	free(this->texcoord);

}