
#include "stdafx.h"
#include "Modeller.h"
#include "MapEditorDlg.h"
#include "MetalWar.h"

float distRayPlane(VECTOR vRayOrigin, VECTOR vnRayVector, VECTOR vnPlaneNormal, float planeD);



void DISPLAY::initCamera(int newresx, int newresy, float newx, float newy, float newz, float newax, float neway, float newaz, float newzoom){
	
	camera.x = camera.cx = camera.dx = newx;
	camera.y = camera.cy = camera.dy = newy;
	camera.z = camera.cz = camera.dz = newz;
	camera.ax = newax;
	camera.ay = neway;
	camera.az = newaz;
	
//	camera.ox = camera.oy = camera.oz = 0.0f;
	camera.zoom = newzoom;
//	camera.zoomdst = newzoom;
//	camera.zoomsrc = newzoom;
	camera.resx = newresx;
	camera.resy = newresy;

	camera.fcp = 1.0f;
	camera.Tshift = camera.resy/2.0f;
	camera.Lshift = camera.resx/2.0f;

}



void CAMERA::handle(void){

	if (ax < -360) ax = 360;
	if (ax > 360) ax = -360;
	if (az < -360) az = 360;
	if (az > 360) az = -360;

	work_out_trig();


/*	float ground_height = 0.0;

//find the distances from the centre-point...
	float horizontal_distance = fabs(cos(DEG2RAD(90-ax)) * zoom);
	float vertical_distance = sin(DEG2RAD(90-ax)) * zoom;

//find the real position of the camera itself...
	x = cx - (horizontal_distance * cos(DEG2RAD(-az+90)));
	y = cy - (horizontal_distance * sin(DEG2RAD(-az+90)));

//set the height of the camera...
	z = cz + vertical_distance + 10;
//clip the height of the camera to the ground height...
	if (z < ground_height + 10) z = ground_height + 10;*/

//work out the matrices for camera transformations...
	D3DXMATRIX t_mat,t_mat2,t_mat3;
	
//all of the different camera/view transforms...
	D3DXMatrixTranslation( &this->DMXtranslation, 0,0,-zoom);
	
	D3DXMatrixRotationYawPitchRoll( &this->DMXrotation, 0.0, DEG2RAD(game.display.camera.ax), DEG2RAD(game.display.camera.az) );
	
	D3DXMatrixMultiply( &this->DMXtotalTransformation, &this->DMXrotation,&this->DMXtranslation );

	D3DXMatrixIdentity( &this->DMXidentity );

	game.devices.g_pd3dDevice->SetTransform(D3DTS_VIEW, &this->DMXtotalTransformation);

}



void CAMERA::work_out_trig(void){


	COSax = cos( DEG2RAD(ax) );
	COSay = cos( DEG2RAD(ay) );
	COSaz = cos( DEG2RAD(az) );

	SINax = sin( DEG2RAD(ax) );
	SINay = sin( DEG2RAD(ay) );
	SINaz = sin( DEG2RAD(az) );

	MINCOSax = cos( DEG2RAD(-ax) );
	MINCOSay = cos( DEG2RAD(-ay) );
	MINCOSaz = cos( DEG2RAD(-az) );

	MINSINax = sin( DEG2RAD(-ax) );
	MINSINay = sin( DEG2RAD(-ay) );
	MINSINaz = sin( DEG2RAD(-az) );

}


//sets the vector's component x,y and z values...

void VECTOR::set(float new_x, float new_y, float new_z){

	x = new_x;
	y = new_y;
	z = new_z;

	nx = 0.0f;
	ny = 0.0f;
	nz = 0.0f;

}


//returns the magnitude of the vector...

float VECTOR::length(void){

	return  sqrt( (x*x) + (y*y) + (z*z) );

}



//makes the components of unit length - magnitude of 1...

void VECTOR::MakeUnit(void){

	float t_length = length();

	x /= t_length;
	y /= t_length;
	z /= t_length;

}





VECTOR CrossProduct( VECTOR v1, VECTOR v2 )
{
	
	VECTOR t_v;
	
	float X = (v1.y * v2.z) -  (v1.z * v2.y);
	float Y = (v1.z * v2.x) -  (v1.x * v2.z);
	float Z = (v1.x * v2.y) -  (v1.y * v2.x);

	t_v.set(X,Y,Z);

	return t_v;
}





float DotProduct( VECTOR v1, VECTOR v2 )
{
  return (v1.x * v2.x) +  (v1.y * v2.y) +  (v1.z * v2.z);
}

float DotProduct( VECTOR *v1, VECTOR *v2 )
{
  return (v1->x * v2->x) +  (v1->y * v2->y) +  (v1->z * v2->z);
}



/*
bool VertexInTriangle(VECTOR vtxPoint, VECTOR vtx0, VECTOR vtx1, VECTOR vtx2)
{
	double dAngle;
	
	VECTOR vec0;
	vec0.set(vtxPoint.x - vtx0.x, vtxPoint.y - vtx0.y,vtxPoint.z - vtx0.z);
	VECTOR vec1;
	vec1.set(vtxPoint.x - vtx1.x, vtxPoint.y - vtx1.y,vtxPoint.z - vtx1.z);
	VECTOR vec2;
	vec2.set(vtxPoint.x - vtx2.x, vtxPoint.y - vtx2.y,vtxPoint.z - vtx2.z);
	
	vec0.MakeUnit();
	vec1.MakeUnit();
	vec2.MakeUnit();
	
	dAngle =
		acos( DotProduct(vec0,vec1) ) + 
		acos( DotProduct(vec1,vec2) ) + 
		acos( DotProduct(vec2,vec0) ) ;
	
	if( fabs( dAngle - 2 * PI ) < 0.01 )
		return true;
	else
		return false;
}
*/

/*
float GetLength(float x,float y,float z){
	if (x<0) x *= -1.0f;
	if (y<0) y *= -1.0f;
	if (z<0) z *= -1.0f;

	return sqrt ( (x*x) + (y*y) + (z*z) );
}
*/

/*
float distRayPlane(VECTOR vRayOrigin, VECTOR vnRayVector, VECTOR vnPlaneNormal, float planeD)
{
    float cosAlpha;
    float deltaD;

    cosAlpha = DotProduct( 
        vnRayVector ,  vnPlaneNormal );

    // parallel to the plane (alpha=90)
    if (cosAlpha==0) return -1.0f;

    deltaD = planeD - 
        DotProduct(vRayOrigin,vnPlaneNormal);
    
    return (deltaD/cosAlpha);
}*/