
#include "stdafx.h"
#include "Modeller.h"
#include "MapEditorDlg.h"
#include "MetalWar.h"



int booleansPerformed = 0;



char current_open_filename[256];
void drawPointSpriteCorner( float x, float y, float z, float sizex, float sizey, TEXTURE_WRAPPER *texture );
void draw3DLine(float ax,float ay,float az,float bx,float by,float bz,int r,int g,int b,int a);


float distRayPlane(VECTOR vRayOrigin, VECTOR vnRayVector, VECTOR vnPlaneNormal, float planeD);
bool VertexInTriangle(VECTOR vtxPoint, VECTOR vtx0, VECTOR vtx1, VECTOR vtx2);


S_MESH *mcube;

S_MESH *tool;

S_MESH *testVert;

S_MESH *testPlane;
S_MESH *testPlane2;


S_VERTEX *testVertVertex;
S_POLY *testPlanePoly;
S_POLY *testPlanePoly2;


void GAME::initialize(void){

	sprintf(game.devices.root_path, "C:/metalwar/");

	display.initCamera (640,480,0,0,50,0,0,0,500);

	display.light_source_direction.set(0.0,0.0,-0.4);

//Set the app view matrix for normal viewing
    FLOAT fAspect = 1.3;
    D3DXMatrixPerspectiveFovRH( &game.display.matView, D3DX_PI/4, fAspect, 1.0f, 6000.0f );

    game.devices.g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &game.display.matView );

	this->resources.first = this->resources.last = NULL;


	mcube = new S_MESH(CUBE);

	tool = new S_MESH(CUBE);


	tool->scale(3,3,1);


}


	int currentPoly = 0;

float floats[100];


void DISPLAY::redraw(void){

	float start_time, end_time;

	start_time = timeGetTime();

	char ach[128];
    int len;

	
	D3DRECT d3dRect;
	RECT Rect,Rect2;
	
    // Clear the backbuffer and the zbuffer
    game.devices.g_pd3dDevice->Clear( 0L, NULL, D3DCLEAR_ZBUFFER | D3DCLEAR_TARGET, 0x00000000, 1.0f, 0L );

    // Begin the scene
    game.devices.g_pd3dDevice->BeginScene();
	
	
	//*** use the blter to do a color fill to clear the back buffer
	game.display.camera.handle();
	game.control.mouse.handle();
	game.control.keyboard.handle();
	

	if (game.control.mouse.Rb){
		game.display.camera.oax = game.display.camera.ax;
		game.display.camera.oaz = game.display.camera.az;
		game.display.camera.ax += game.control.mouse.y-game.control.mouse.oy;
		game.display.camera.az += game.control.mouse.x-game.control.mouse.ox;
	}
	if (game.control.mouse.Mb){
		game.display.camera.zoom += (game.control.mouse.y-game.control.mouse.oy);
	}

    game.devices.g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE,   TRUE );
	
	D3DXMATRIX transform;
	D3DXMatrixTranslation( &transform, 0,0,0);
	game.devices.g_pd3dDevice->SetTransform(D3DTS_WORLDMATRIX(0), &transform);




	if (getkey(RK_ESCAPE)) game.end();
	
//	sprintf(ach, "[%d]\nMCUBE: v%d p%d\nTOOL: v%d p%d",booleansPerformed,mcube->numVerts, mcube->numPolys,tool->numVerts, tool->numPolys);
//	game.display.HUDFont->DrawText(220,20,D3DCOLOR_ARGB(255,255,255,255), ach);

//===================================================================================
	
/*	VECTOR cnorm;
	if (mcube->polygon(currentPoly)) cnorm = mcube->polygon(currentPoly)->findNormal();

	sprintf(ach, "[CP = %d] edge=%d normal=%f,%f,%f",currentPoly, mcube->polygon(currentPoly)->numEdges, cnorm.x, cnorm.y, cnorm.z);
	game.display.HUDFont->DrawText(220,50,D3DCOLOR_ARGB(255,255,255,255), ach);

	if (game.control.keyboard.keypressed['P']) currentPoly++;
	if (game.control.keyboard.keypressed['L']) currentPoly--;
	if (game.control.keyboard.keypressed['M'] && mcube->numPolys > 1) (*mcube) -= mcube->polygon(currentPoly);
*/

//extern int		numIntPolys;
	

/*	extern S_POLY	*intPolys[1000];
	extern int		numIntPolys;
	extern int		numUnintPolys;
		


	for (int cpi=0;cpi<numIntPolys;cpi++)
	{
		for (int cp=0;cp<intPolys[cpi]->num_ints;cp++)
		{
			sprintf(ach, "%d-> %d (%0.1f, %0.1f, %0.1f)", cp, intPolys[cpi]->v_ints[cp].type,intPolys[cpi]->v_ints[cp].intersectPoint->x,intPolys[cpi]->v_ints[cp].intersectPoint->y,intPolys[cpi]->v_ints[cp].intersectPoint->z);
			game.display.HUDFont->DrawText(50 + (cpi*125),20 + (cp*20),D3DCOLOR_ARGB(255,255,255,255), ach);
		}
	}

	
	sprintf(ach, "%d", mcube->numPolys);
	game.display.HUDFont->DrawText(20,20,D3DCOLOR_ARGB(255,255,255,255), ach);
*/



	for (int ca=0;ca<100;ca++)
	{
		sprintf(ach, "%f", floats[ca]);
		game.display.HUDFont->DrawText(20,20+(ca*15),D3DCOLOR_ARGB(255,255,255,255), ach);
	}




/*	int a = 0;
	S_POLY *cpoly = mcube->pfirst;
	while(cpoly)
	{

		sprintf(ach, "%d	%d", cpoly->addedAsIntersected, cpoly->addedAsUnintersected);
		game.display.HUDFont->DrawText(50,20+(20*a),D3DCOLOR_ARGB(255,255,255,255), ach);
		a++;
		cpoly = cpoly->pnext;
	}*/

	mcube->draw();

	mcube->retrieveBounds();

	tool->retrieveBounds();

	//tool->translate( (game.control.mouse.cmx - game.control.mouse.ocmx), -(game.control.mouse.cmy - game.control.mouse.ocmy),  -(tool->bb_lower - (100-25)));//mcube->bb_upper - 25)) );
	if (!game.control.mouse.Rb) tool->translate( (game.control.mouse.cmx - game.control.mouse.ocmx), -(game.control.mouse.cmy - game.control.mouse.ocmy),  -(tool->bb_lower - (mcube->bb_upper - 25)) );

	tool->draw();


	if (game.control.mouse.Lclicked) 
	{
		mcube = mcube->booleanIntersect( tool );

		tool = new S_MESH(CUBE);
		tool->scale(3,3,1);
	
	}






//	if (game.control.mouse.Lb) testVert->translate(1,0,0);
//	if (game.control.mouse.Rb) testVert->translate(1,0,0);


//===================================================================================


    // End the scene
    game.devices.g_pd3dDevice->EndScene();

    // Present the backbuffer contents to the display
    game.devices.g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	end_time = timeGetTime();

    game.display.avtime = 50.0;

	game.control.mouse.un_click();
 
}




//#####################################################################################################################################################################

int SearchDirectory(char PATH[]){
int j,a;

	j=0;
	for (a=0;a!=_MAX_FNAME;a++){ 
		game.resources.c_file[j].name[a] = 0; 
	}
	game.resources.hFile = _findfirst( PATH, &game.resources.c_file[j] );
	j=1;

	do{
		for (a=0;a!=_MAX_FNAME;a++){ 
			game.resources.c_file[j].name[a] = 0; 
		}
		int result = _findnext( game.resources.hFile, &game.resources.c_file[j] ) ;
		if (result==-1) return j;
		j++;
	} while (j<250);

	return j;
}


//#####################################################################################################################################################################





















