

#include "stdafx.h"

#include "MetalWar.h"






//#####################################################################################################################################################################
// draw_2D_coloured_point_sprite() - draws a point sprite at the 2D position with finer controls...

void draw_2D_coloured_point_sprite( float x, float y, float z, float sizex, float sizey, float r, float g, float b, float a, TEXTURE_WRAPPER *texture ){


		game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_2DpVB, sizeof(CUSTOM2DVERTEX) );
		game.devices.g_pd3dDevice->SetVertexShader( D3DFVF_CUSTOM2DVERTEX );

		CUSTOM2DVERTEX vTemp[10];
		
//		texture->set();
		
		vTemp[0].x = x-sizex;
		vTemp[0].y = y-sizey;
		vTemp[0].z = z;
		vTemp[0].rhw = 1.0f/z;
		vTemp[0].color = D3DCOLOR_RGBA((int)r, (int)g, (int)b,(int)a);
		vTemp[0].tu=0.0f;
		vTemp[0].tv=0.0f;
		
		vTemp[1].x = x+sizex;
		vTemp[1].y = y-sizey;
		vTemp[1].z = z;
		vTemp[1].rhw = 1.0f/z;
		vTemp[1].color = D3DCOLOR_RGBA((int)r, (int)g, (int)b,(int)a);
		vTemp[1].tu=1.0f;
		vTemp[1].tv=0.0f;
		
		vTemp[2].x = x+sizex;
		vTemp[2].y = y+sizey;
		vTemp[2].z = z;
		vTemp[2].rhw = 1.0f/z;
		vTemp[2].color = D3DCOLOR_RGBA((int)r, (int)g, (int)b,(int)a);
		vTemp[2].tu=1.0f;
		vTemp[2].tv=1.0f;
		
		vTemp[3].x = x-sizex;
		vTemp[3].y = y+sizey;
		vTemp[3].z = z;
		vTemp[3].rhw = 1.0f/z;
		vTemp[3].color = D3DCOLOR_RGBA((int)r, (int)g, (int)b,(int)a);
		vTemp[3].tu=0.0f;
		vTemp[3].tv=1.0f;
		

		game.devices.g_2DpVB->Lock( 0, 0, (BYTE**)&game.display.t_2Dvb, 0 );

		game.display.t_2Dvb[0] = vTemp[0];
		game.display.t_2Dvb[1] = vTemp[1];
		game.display.t_2Dvb[2] = vTemp[2];
		
		game.display.t_2Dvb[3] = vTemp[0];
		game.display.t_2Dvb[4] = vTemp[2];
		game.display.t_2Dvb[5] = vTemp[3];

		game.devices.g_2DpVB->Unlock();
		game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLELIST, 0,2);


		game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
		game.devices.g_pd3dDevice->SetVertexShader( D3DFVF_CUSTOMVERTEX );

}




//#####################################################################################################################################################################
// drawPointSpriteCorner() - draws a point sprite at the position as the top-left corner...

void drawPointSpriteCorner( float x, float y, float z, float sizex, float sizey, TEXTURE_WRAPPER *texture ){
	
	game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_2DpVB, sizeof(CUSTOM2DVERTEX) );
	game.devices.g_pd3dDevice->SetVertexShader( D3DFVF_CUSTOM2DVERTEX );
	
	CUSTOM2DVERTEX *vTemp;
	
//	texture->set();
	game.devices.g_2DpVB->Lock( 0, 0, (BYTE**) &vTemp, 0 );


/*

	2		4



	1		3

*/


	vTemp[0].x = x;
	vTemp[0].y = y+sizey;
	vTemp[0].z = z;
	vTemp[0].rhw = 1.0f/z;
	vTemp[0].color = D3DCOLOR_RGBA((int)255, (int)255, (int)255,255);
	vTemp[0].tu=0.0f;
	vTemp[0].tv=1.0f;
	
	vTemp[1].x = x;
	vTemp[1].y = y;
	vTemp[1].z = z;
	vTemp[1].rhw = 1.0f/z;
	vTemp[1].color = D3DCOLOR_RGBA((int)255, (int)255, (int)255,255);
	vTemp[1].tu=0.0f;
	vTemp[1].tv=0.0f;
	
	vTemp[2].x = x+sizex;
	vTemp[2].y = y+sizey;
	vTemp[2].z = z;
	vTemp[2].rhw = 1.0f/z;
	vTemp[2].color = D3DCOLOR_RGBA((int)255, (int)255, (int)255,255);
	vTemp[2].tu=1.0f;
	vTemp[2].tv=1.0f;
	
	vTemp[3].x = x+sizex;
	vTemp[3].y = y;
	vTemp[3].z = z;
	vTemp[3].rhw = 1.0f/z;
	vTemp[3].color = D3DCOLOR_RGBA((int)255, (int)255, (int)255,255);
	vTemp[3].tu=1.0f;
	vTemp[3].tv=0.0f;
	
	game.devices.g_2DpVB->Unlock();
	game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0,2);
	
	game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
	game.devices.g_pd3dDevice->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	
}




//#####################################################################################################################################################################
// draws a line between these two sets of coordinates with the specified colour and transparency...

void draw3DLine(float ax,float ay,float az,float bx,float by,float bz,int r,int g,int b,int a){

CUSTOMVERTEX *tCv;

game.devices.g_pVB->Lock( 0, 0, (BYTE**) &tCv, 0 );

tCv[0].p = D3DXVECTOR3(ax,ay,az);
tCv[0].color = D3DCOLOR_RGBA(r,g,b,a);
tCv[0].tu=0.0;
tCv[0].tv=0.0;

tCv[1].p = D3DXVECTOR3(bx,by,bz);
tCv[1].color = D3DCOLOR_RGBA(r,g,b,a);
tCv[1].tu=0.0;
tCv[1].tv=0.0;

game.devices.g_pVB->Unlock();

game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, 0,1);


}


//#####################################################################################################################################################################


