// MapEditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEditor.h"
#include "MapEditorDlg.h"
#include "metalwar.h"
#include "LoadTileset.h"
#include "DialogResizeMap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HRESULT InitD3D(void);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapEditorDlg dialog

CMapEditorDlg::CMapEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMapEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapEditorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMapEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapEditorDlg)
	DDX_Control(pDX, LISTconsole, m_LISTconsole);
	DDX_Control(pDX, MAINVIEW, m_MAINVIEW);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMapEditorDlg, CDialog)
	//{{AFX_MSG_MAP(CMapEditorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_BN_CLICKED(BTnewMap, OnBTnewMap)
	ON_BN_CLICKED(BTsaveMap, OnBTsaveMap)
	ON_BN_CLICKED(BTloadMap, OnBTloadMap)
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapEditorDlg message handlers

BOOL CMapEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon



	game.devices.hwndApp = this->m_MAINVIEW.GetSafeHwnd();

	sprintf(game.devices.root_path, "c:/metalwar/");

//initialise Direct3D elements...	
	InitD3D();

	game.mainDialog = this;

	this->SetTimer(1, 50.0, NULL);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMapEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMapEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMapEditorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMapEditorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	

	game.display.redraw();


	CDialog::OnTimer(nIDEvent);
}



void CMapEditorDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	game.control.mouse.Lb = 1;

	CDialog::OnLButtonDown(nFlags, point);
}

void CMapEditorDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (game.control.mouse.Lb) game.control.mouse.Lclicked = 1;
	game.control.mouse.Lb = 0;
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CMapEditorDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	game.control.mouse.Rb = 1;
	
	CDialog::OnRButtonDown(nFlags, point);
}

void CMapEditorDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (game.control.mouse.Rb) game.control.mouse.Rclicked = 1;
	game.control.mouse.Rb = 0;
	
	CDialog::OnRButtonUp(nFlags, point);
}



void CMapEditorDlg::OnBTnewMap() 
{
	// TODO: Add your control notification handler code here
	
	DialogCreateMap tCreateMap;
	tCreateMap.DoModal();
}

void CMapEditorDlg::OnBTsaveMap() 
{
	// TODO: Add your control notification handler code here
	
	DialogSaveMap tSaveMap;
	tSaveMap.DoModal();
}

void CMapEditorDlg::OnBTloadMap() 
{
	// TODO: Add your control notification handler code here
	
	DialogLoadMap tLoadMap;
	tLoadMap.DoModal();
}




BOOL CMapEditorDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: Add your message handler code here and/or call default
	
	game.display.camera.zoom += zDelta;

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

