
#include "stdafx.h"
#include "Modeller.h"
#include "MetalWar.h"



//#################################################################################################################################################################

S_MESH::S_MESH(char filename[]){

//stitch together linklist....
	this->mlast = game.resources.last;
	this->mnext = NULL;
	if (this->mlast) this->mlast->mnext = this;
	game.resources.last = this;

	this->numVerts = this->numPolys = 0;
	
//init polygon info....	
	this->pfirst = this->plast = NULL;

}

//#################################################################################################################################################################

S_MESH::S_MESH(S_PRIMITIVE_TYPE type){

//stitch together linklist....
	this->mlast = game.resources.last;
	this->mnext = NULL;
	if (this->mlast) this->mlast->mnext = this;
	game.resources.last = this;

	this->numVerts = this->numPolys = 0;

//init vertex info....	
	this->pfirst = this->plast = NULL;

//if a cube, add the new faces...
	if (type == CUBE){

		(*this) += new S_POLY( new S_VERTEX(-100,-100,-100), new S_VERTEX(+100,-100,-100), new S_VERTEX(+100,+100,-100), new S_VERTEX(-100,+100,-100) );

		(*this) += new S_POLY( new S_VERTEX(-100,+100,+100), new S_VERTEX(+100,+100,+100), new S_VERTEX(+100,-100,+100), new S_VERTEX(-100,-100,+100) );

		(*this) += new S_POLY( new S_VERTEX(-100,-100,-100), new S_VERTEX(-100,+100,-100), new S_VERTEX(-100,+100,+100), new S_VERTEX(-100,-100,+100) );

		(*this) += new S_POLY( new S_VERTEX(-100,+100,-100), new S_VERTEX(+100,+100,-100), new S_VERTEX(+100,+100,+100), new S_VERTEX(-100,+100,+100) );

		(*this) += new S_POLY( new S_VERTEX(+100,+100,-100), new S_VERTEX(+100,-100,-100), new S_VERTEX(+100,-100,+100), new S_VERTEX(+100,+100,+100) );

		(*this) += new S_POLY( new S_VERTEX(+100,-100,-100), new S_VERTEX(-100,-100,-100), new S_VERTEX(-100,-100,+100), new S_VERTEX(+100,-100,+100) );

	}
}

//#################################################################################################################################################################

S_MESH::S_MESH(S_MESH *copyMesh){

//stitch together linklist....
	this->mlast = game.resources.last;
	this->mnext = NULL;
	if (this->mlast) this->mlast->mnext = this;
	game.resources.last = this;

	this->numVerts = this->numPolys = 0;

//init vertex info....	
	this->pfirst = this->plast = NULL;




//add all polygons to the new mesh...
	S_POLY *cpoly = copyMesh->pfirst;
	while( cpoly )
	{
		S_POLY *newPoly = new S_POLY();

		S_VERTEX *currentVertex = cpoly->firstVertex;
		while(1)
		{
			if (!currentVertex) break;
			
			S_VERTEX *newVertex = new S_VERTEX( *currentVertex );
			(*newPoly) += newVertex;
			
			S_EDGE *thisEdge = currentVertex->nextEdge;
			if (!thisEdge) break;

			S_EDGE	*newEdge = new S_EDGE(thisEdge->isFirstEdge);
			newVertex->nextEdge = newEdge;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			if (!nextVertex) break;

			S_VERTEX *newVertexB = new S_VERTEX( *nextVertex );
			(*newPoly) += newVertexB;

			newEdge->nextVertex = newVertexB;
			newVertexB->nextEdge = NULL;
			
			currentVertex = nextVertex;
		}

		(*this) += newPoly;

		cpoly = cpoly->pnext;
	}



}


//#################################################################################################################################################################

void S_MESH::copyVisibleFrom(S_MESH *copyFromMesh){

/*	S_POLY *cpoly = copyFromMesh->pfirst;

	do {

		if (!cpoly) break;


		if (!cpoly->invisible){

			S_VERTEX *newv1 = new S_VERTEX( *(cpoly->vv1) );
			S_VERTEX *newv2 = new S_VERTEX( *(cpoly->vv2) );
			S_VERTEX *newv3 = new S_VERTEX( *(cpoly->vv3) );

			(*this) += newv1;
			(*this) += newv2;
			(*this) += newv3;

			S_POLY *newPolygon = new S_POLY( newv1, newv2, newv3 );

			(*this) += newPolygon;
		}


		cpoly = cpoly->pnext;
	} while(1);*/

}

//#################################################################################################################################################################

S_MESH::~S_MESH(){


}



//#################################################################################################################################################################

void S_MESH::operator += (S_POLY *p){

	if (!p) return;

	this->numPolys ++;

	p->plast = this->plast;
	p->pnext = NULL;
	if (p->plast) p->plast->pnext = p;
	this->plast = p;
	
	if (!this->pfirst) this->pfirst = this->plast;

	p->parentMesh = this;
}



//#################################################################################################################################################################

void S_MESH::operator -= (S_POLY *p){

	if (!p) return;

	this->numPolys --;

	if (p->plast){
		p->plast->pnext = p->pnext;
	}

	if (p->pnext){
		p->pnext->plast = p->plast;
	}

	if (p == this->pfirst) this->pfirst = p->pnext;
	if (p == this->plast) this->plast = p->plast;

	delete p;
}


//#################################################################################################################################################################

void S_MESH::removePolygon(S_POLY *p){

	if (!p) return;

	this->numPolys --;

	if (p->plast){
		p->plast->pnext = p->pnext;
	}

	if (p->pnext){
		p->pnext->plast = p->plast;
	}

	if (p == this->pfirst) this->pfirst = p->pnext;
	if (p == this->plast) this->plast = p->plast;

	delete p;
}


//#################################################################################################################################################################

S_VERTEX *S_MESH::findVertex(float x, float y, float z){

/*	S_VERTEX *cvert = this->vfirst;

	do {

		if (!cvert) break;


		if ( x == cvert->x && y == cvert->y && z == cvert->z ) return cvert;

			
		cvert = cvert->vnext;

	} while(1);*/

	return NULL;
}

//#################################################################################################################################################################

void S_MESH::draw(void){

	//this->light();

	S_POLY *cp = this->pfirst;

	while(cp)
	{
		if (!cp->invisible) cp->draw();

		cp = cp->pnext;

	}


	S_POLY *cpoly = this->pfirst;
	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;
		while(1)
		{
			if (!currentVertex) break;
			
			CUSTOMVERTEX *tCv;

			game.devices.g_pVB->Lock( 0, 0, (BYTE**) &tCv, 0 );

			tCv[0].p = D3DXVECTOR3(currentVertex->x,currentVertex->y,currentVertex->z);
			tCv[0].color = D3DCOLOR_RGBA((int)255,(int)255,(int)255, 255);
			tCv[0].tu=0.0;
			tCv[0].tv=0.0;

			game.devices.g_pVB->Unlock();

			game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
			game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_POINTLIST, 0,1);
			
			
			S_EDGE *thisEdge = currentVertex->nextEdge;
			if (!thisEdge) break;
			S_VERTEX *nextVertex = thisEdge->nextVertex;
			if (!nextVertex) break;
			currentVertex = nextVertex;

			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;

	}


/*	char ach[128];
	sprintf(ach, "%d  %d", this->numVerts, this->numPolys );
	game.display.HUDFont->DrawText(220,20,D3DCOLOR_ARGB(255,255,255,255), ach);
*/
}

//#################################################################################################################################################################

S_VERTEX::S_VERTEX(float x, float y, float z, float tu, float tv){

	this->nextEdge = NULL;
	this->lastEdge = NULL;

	this->testFlag = 0;

	this->x = x;
	this->y = y;
	this->z = z;
	
	this->r = 255;
	this->g = 255;
	this->b = 255;

	this->tu = tu;
	this->tv = tv;
}

//#################################################################################################################################################################

S_VERTEX::S_VERTEX(void){

	this->nextEdge = NULL;
	this->lastEdge = NULL;

	this->testFlag = 0;
	
	this->x = 0;
	this->y = 0;
	this->z = 0;
	
	this->r = 255;
	this->g = 255;
	this->b = 255;

	this->tu = 0;
	this->tv = 0;
}
//#################################################################################################################################################################

int S_VERTEX::isSame( S_VERTEX *v ){

	return (this->x == v->x && this->y == v->y && this->z == v->z);
	
}

int S_VERTEX::isSame( S_VERTEX *v, double error ){

	return (this->x >= v->x - error && this->x <= v->x + error && this->y >= v->y - error && this->y <= v->y + error && this->z >= v->z - error && this->z <= v->z + error);
	
}

//#################################################################################################################################################################

void S_VERTEX::retrieve( D3DXVECTOR3 *point, D3DCOLOR *color){

	point = new D3DXVECTOR3( this->x, this->y, this->z );
	color = new D3DCOLOR( this->r, this->g, this->b );

}

//#################################################################################################################################################################

void S_VERTEX::retrieve( float *nx, float *ny, float *nz){

	*nx = this->x;
	*ny = this->y;
	*nz = this->z;
}

//#################################################################################################################################################################

void S_VERTEX::set( D3DXVECTOR3 *point, D3DCOLOR *color){

	this->x = point->x;
	this->y = point->y;
	this->z = point->z;

}

//#################################################################################################################################################################

void S_VERTEX::set( float nx, float ny, float nz ){

	this->x = nx;
	this->y = ny;
	this->z = nz;

}

//#################################################################################################################################################################

S_VERTEX::~S_VERTEX(){

}

//#################################################################################################################################################################


S_POLY::S_POLY(S_VERTEX *nv1, S_VERTEX *nv2, S_VERTEX *nv3, S_VERTEX *nv4){

	this->invisible = 0;
	
	this->numEdges = 4;

	this->part = 1;
	
	this->meshPart = S_MP_UNDECIDED;
	
	this->addedAsUnintersected = 0;
	this->addedAsIntersected = 0;

	this->num_ints = 0;
	
	this->plast = NULL;
	this->pnext = NULL;

	this->firstVertex = NULL;
	this->lastVertex = NULL;

	this->lastEdge = NULL;

//add the vertex and edges to the polygon...
	(*this) += nv1;
	S_EDGE	*newEdge = new S_EDGE(1);
	(*nv1) += newEdge;
	(*newEdge) += nv2;
	newEdge = new S_EDGE(0);
	(*nv2) += newEdge;
	(*newEdge) += nv3;
	newEdge = new S_EDGE(0);
	(*nv3) += newEdge;	
	(*newEdge) += nv4;
	newEdge = new S_EDGE(0);
	(*nv4) += newEdge;
	(*newEdge) += nv1;

}


//#################################################################################################################################################################

S_POLY::S_POLY(void){

	this->invisible = 0;
	this->intersected = 0;
	
	this->meshPart = S_MP_UNDECIDED;

	this->part = 1;
	
	this->addedAsUnintersected = 0;
	this->addedAsIntersected = 0;

	this->numEdges = 0;

	this->firstVertex = this->lastVertex = NULL;
	this->lastEdge = NULL;

	this->num_ints = 0;
	
	this->plast = NULL;
	this->pnext = NULL;

}

//#################################################################################################################################################################

/*
VECTOR	S_POLY::findNormal( void )
{

	VECTOR Edge1, Edge2, t_NormalA;
	
	Edge1.set(	this->firstVertex->x - this->firstVertex->nextEdge->nextVertex->x, 
					this->firstVertex->y - this->firstVertex->nextEdge->nextVertex->y,
						this->firstVertex->z - this->firstVertex->nextEdge->nextVertex->z );
	
	Edge2.set(	this->firstVertex->nextEdge->nextVertex->nextEdge->nextVertex->x - this->firstVertex->nextEdge->nextVertex->x, 
					this->firstVertex->nextEdge->nextVertex->nextEdge->nextVertex->y - this->firstVertex->nextEdge->nextVertex->y, 
						this->firstVertex->nextEdge->nextVertex->nextEdge->nextVertex->z - this->firstVertex->nextEdge->nextVertex->z );


	t_NormalA = MWCrossProduct(&Edge1, &Edge2);
	t_NormalA.MakeUnit();

	return t_NormalA;
}*/





VECTOR	S_POLY::findNormal( void )
{

	VECTOR normal;
	
	float ca=0,cb=0,cc=0;


	S_VERTEX *currentVertex = this->firstVertex;
	while(1)
	{
		if (!currentVertex) break;
		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		if (!thisEdge) break;
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		if (!nextVertex) break;

		
		ca += (currentVertex->y - nextVertex->y) * (currentVertex->z + nextVertex->z);
		
		cb += (currentVertex->z - nextVertex->z) * (currentVertex->x + nextVertex->x);
		
		cc += (currentVertex->x - nextVertex->x) * (currentVertex->y + nextVertex->y);
		
		
		currentVertex = nextVertex;
		
		if (currentVertex == this->firstVertex) break;
	}


	normal.x = -ca;
	normal.y = -cb;
	normal.z = -cc;


	normal.MakeUnit();

	return normal;
}



//#################################################################################################################################################################
//#################################################################################################################################################################

S_POLY::operator += (S_VERTEX *vn){
	this->firstVertex = vn;
}

//#################################################################################################################################################################

S_EDGE::operator += (S_VERTEX *vn){
	this->nextVertex = vn;
	vn->lastEdge = this;
}

//#################################################################################################################################################################

S_VERTEX::operator += (S_EDGE *en){
	this->nextEdge = en;
	en->lastVertex = this;
}

//#################################################################################################################################################################

S_EDGE::S_EDGE( int n_isFirstEdge ){

	this->isFirstEdge = isFirstEdge;
	this->visible = 1;
	this->nextVertex = NULL;

	this->intersected = 0;
	this->v_int = NULL;
}

//#################################################################################################################################################################

S_POLY::~S_POLY(){

}

//#################################################################################################################################################################
// polygon - index->pointer conversion...

S_POLY	*S_MESH::polygon( int index )
{

	S_POLY *current = this->pfirst;
	int	currentIndex = 0;

	while( current && currentIndex < index )
	{
		current = current->pnext;
		currentIndex++;
	}

	if (current) return current;
	return this->pfirst;
}

//#################################################################################################################################################################
// draw() - draws (renders) this triangle/polygon...

void S_POLY::draw(int r, int g, int b){


 	CUSTOMVERTEX *tCv;

	S_VERTEX *currentVertex = this->firstVertex;

	VECTOR	normal;

	normal = this->findNormal();

	float xs = normal.x*2.0;
	float ys = normal.y*2.0;
	float zs = normal.z*2.0;


	float vertcentx = 0.0;
	float vertcenty = 0.0;
	float vertcentz = 0.0;
	int numVerts = 0;

	while(1)
	{

		if (!currentVertex) break;

		S_EDGE *thisEdge = currentVertex->nextEdge;
	
		if (!thisEdge) break;

		S_VERTEX *nextVertex = thisEdge->nextVertex;
		
		if (!nextVertex) break;



		vertcentx += currentVertex->x;
		vertcenty += currentVertex->y;
		vertcentz += currentVertex->z;

		numVerts ++;

		if (thisEdge->visible)
		{

			if (this->meshPart == S_MP_UNDECIDED)
			{
				game.devices.g_pVB->Lock( 0, 0, (BYTE**) &tCv, 0 );
				
				tCv[0].p = D3DXVECTOR3(currentVertex->x+xs,currentVertex->y+ys,currentVertex->z+zs);
				tCv[0].color = D3DCOLOR_RGBA(50,255,50, 255);
				
				tCv[0].tu=0.0;
				tCv[0].tv=0.0;

				tCv[1].p = D3DXVECTOR3(nextVertex->x+xs,nextVertex->y+ys,nextVertex->z+zs);
				tCv[1].color = D3DCOLOR_RGBA(0,155,0, 255);
					
				tCv[1].tu=0.0;
				tCv[1].tv=0.0;
				
				game.devices.g_pVB->Unlock();

				game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
				game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, 0,2);
			}
			else
			{
				game.devices.g_pVB->Lock( 0, 0, (BYTE**) &tCv, 0 );
				
				tCv[0].p = D3DXVECTOR3(currentVertex->x+xs,currentVertex->y+ys,currentVertex->z+zs);
				tCv[0].color = D3DCOLOR_RGBA(50,50,255, 255);
				
				tCv[0].tu=0.0;
				tCv[0].tv=0.0;

				tCv[1].p = D3DXVECTOR3(nextVertex->x+xs,nextVertex->y+ys,nextVertex->z+zs);
				tCv[1].color = D3DCOLOR_RGBA(0,0,155, 255);
					
				tCv[1].tu=0.0;
				tCv[1].tv=0.0;
				
				game.devices.g_pVB->Unlock();

				game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
				game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, 0,2);
			}



		}

		currentVertex = nextVertex;
			
		if (currentVertex == this->firstVertex) break;
	}

	vertcentx /= (float)numVerts;
	vertcenty /= (float)numVerts;
	vertcentz /= (float)numVerts;


	game.devices.g_pVB->Lock( 0, 0, (BYTE**) &tCv, 0 );
				
	tCv[0].p = D3DXVECTOR3(vertcentx,vertcenty,vertcentz);
	tCv[0].color = D3DCOLOR_RGBA(50,255,50, 255);
				
	tCv[0].tu=0.0;
	tCv[0].tv=0.0;
				
	tCv[1].p = D3DXVECTOR3(vertcentx+(xs*10.0),vertcenty+(ys*10.0),vertcentz+(zs*10.0));
	tCv[1].color = D3DCOLOR_RGBA(0,155,0, 255);
				
	tCv[1].tu=0.0;
	tCv[1].tv=0.0;
				
	game.devices.g_pVB->Unlock();
				
	game.devices.g_pd3dDevice->SetStreamSource( 0, game.devices.g_pVB, sizeof(CUSTOMVERTEX) );
	game.devices.g_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, 0,2);


}



//#################################################################################################################################################################

void S_POLY::flip(void){
	
	S_VERTEX *currentVertex = this->firstVertex;
	
	while(1)
	{
		
		if (!currentVertex) break;
		
//go to next vertex....		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		if (!thisEdge) break;
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		if (!nextVertex) break;
		
//then reset to face backwards...
		S_EDGE *tEdge = currentVertex->nextEdge;
		currentVertex->nextEdge = currentVertex->lastEdge;
		currentVertex->lastEdge = tEdge;
		S_VERTEX *tVertex = thisEdge->nextVertex;
		thisEdge->nextVertex = thisEdge->lastVertex;
		thisEdge->lastVertex = tVertex;

		currentVertex = nextVertex;
		if (currentVertex == this->firstVertex) break;
	}
		
}



void S_POLY::reset()
{

	this->num_ints = 0;
	this->addedAsIntersected = 0;
	this->addedAsUnintersected = 0;

	this->intersected = 0;
	this->intersectedPointsGenerated = 0;
	
	this->invisible = 0;

	this->flipAfter = 0;
}


//###################################################################################################################################################################
// rotatex() - rotates the mesh...

void S_MESH::rotatex(double ax){

	if (ax == 0.0) return;

	ax = DEG2RAD(ax);

	double sinx = sin(ax);
	double cosx = cos(ax);
	
	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;

		while(1)
		{

			if (!currentVertex) break;

			double sy = (currentVertex->y * cosx) + (currentVertex->z * -sinx);
			double sz = (currentVertex->y * sinx) + (currentVertex->z * cosx);

			currentVertex->y = sy;
			currentVertex->z = sz;


			S_EDGE *thisEdge = currentVertex->nextEdge;
		
			if (!thisEdge) break;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			
			if (!nextVertex) break;

			


			currentVertex = nextVertex;
			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;
	}
}


//#####################################################################################################################################################################
// rotatez() - rotates the mesh...

void S_MESH::rotatez(double az){

	if (az == 0.0) return;

	az = DEG2RAD(az);

	double sinz = sin(az);
	double cosz = cos(az);

	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;

		while(1)
		{

			if (!currentVertex) break;

			double nsx = (currentVertex->x * cosz) + (currentVertex->z * -sinz);
			double nsz = (currentVertex->x * sinz) + (currentVertex->z * cosz);

			currentVertex->x = nsx;
			currentVertex->z = nsz;

			S_EDGE *thisEdge = currentVertex->nextEdge;
		
			if (!thisEdge) break;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			
			if (!nextVertex) break;

			


			currentVertex = nextVertex;
			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;
	}

}


//#####################################################################################################################################################################
// rotatez() - rotates the mesh...

void S_MESH::translate(float x, float y, float z){

	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;

		while(1)
		{

			if (!currentVertex) break;

			currentVertex->x += x;
			currentVertex->y += y;
			currentVertex->z += z;

			S_EDGE *thisEdge = currentVertex->nextEdge;
		
			if (!thisEdge) break;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			
			if (!nextVertex) break;

			


			currentVertex = nextVertex;
			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;
	}

}

//#####################################################################################################################################################################
// scale() - scales the mesh...

void S_MESH::scale(float x, float y, float z){


	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;

		while(1)
		{

			if (!currentVertex) break;

			currentVertex->x *= x;
			currentVertex->y *= y;
			currentVertex->z *= z;

			S_EDGE *thisEdge = currentVertex->nextEdge;
		
			if (!thisEdge) break;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			
			if (!nextVertex) break;

			


			currentVertex = nextVertex;
			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;
	}
}

//#####################################################################################################################################################################
// retrieveBounds() - finds the bounding-box and stores the information...

void S_MESH::retrieveBounds(void){

	this->bb_left = 1000000.0;
	this->bb_right = -1000000.0;

	this->bb_back = 1000000.0;
	this->bb_front = -1000000.0;

	this->bb_lower = 1000000.0;
	this->bb_upper = -1000000.0;


	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{

		S_VERTEX *currentVertex = cpoly->firstVertex;

		while(1)
		{

			if (!currentVertex) break;


			if (currentVertex->x < this->bb_left) this->bb_left = currentVertex->x;
			if (currentVertex->x > this->bb_right) this->bb_right = currentVertex->x;

			if (currentVertex->y < this->bb_back) this->bb_back = currentVertex->y;
			if (currentVertex->y > this->bb_front) this->bb_front = currentVertex->y;

			if (currentVertex->z < this->bb_lower) this->bb_lower = currentVertex->z;
			if (currentVertex->z > this->bb_upper) this->bb_upper = currentVertex->z;

			
			
			S_EDGE *thisEdge = currentVertex->nextEdge;
		
			if (!thisEdge) break;

			S_VERTEX *nextVertex = thisEdge->nextVertex;
			
			if (!nextVertex) break;

			currentVertex = nextVertex;
			if (currentVertex == cpoly->firstVertex) break;
		}

		cpoly = cpoly->pnext;
	}




	if (this->bb_left == 1000000.0) this->bb_left = 0.0;
	if (this->bb_right == -1000000.0) this->bb_right = 0.0;

	if (this->bb_back == 1000000.0) this->bb_back = 0.0;
	if (this->bb_front == -1000000.0) this->bb_front = 0.0;

	if (this->bb_lower == 1000000.0) this->bb_lower = 0.0;
	if (this->bb_upper == -1000000.0) this->bb_upper = 0.0;

}


//#####################################################################################################################################################################


int S_POLY::isPointInside( float x, float y, float z ){


	VECTOR *vec = new VECTOR[ 50 ];

	double dAngle = 0;
	int numParts = 0;


	S_VERTEX *currentVertex = this->firstVertex;
	while(1)
	{
		if (!currentVertex) break;
		
		vec[numParts].set(x - currentVertex->x, y - currentVertex->y, z - currentVertex->z);
		vec[numParts].MakeUnit();
		
		numParts ++;
		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		if (!thisEdge) break;
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		if (!nextVertex) break;
		currentVertex = nextVertex;
		if (currentVertex == this->firstVertex) break;
	}

	int numParts2 = 0;

	currentVertex = this->firstVertex;
	while(1)
	{
		if (!currentVertex) break;
		
		if (numParts2 < numParts - 1) dAngle += acos( MWDotProduct(&vec[numParts2],&vec[numParts2+1]) );
			else dAngle += acos( MWDotProduct(&vec[numParts2],&vec[0]) );
		
		numParts2 ++;
		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		if (!thisEdge) break;
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		if (!nextVertex) break;
		currentVertex = nextVertex;
		if (currentVertex == this->firstVertex) break;
	}

	delete [] vec;

	if( fabs( dAngle - 2 * PI ) < 0.1 )
		return true;
	else
		return false;
}


//#####################################################################################################################################################################
// addLighting() - adds lighting to this texture subset...

void S_MESH::light(void){
/*
	S_POLY *cp = this->pfirst;

	do{

		if (!cp) break;

		VECTOR Edge1, Edge2;
		float t_Shade;
		VECTOR   t_Normal;
		float AmbientLight = 0.4;


		Edge1.set(cp->e[0].v2->x - cp->e[0].v1->x,cp->e[0].v2->y - cp->e[0].v1->y,cp->e[0].v2->z - cp->e[0].v1->z);
		Edge1.set(cp->e[1].v2->x - cp->e[1].v1->x,cp->e[1].v2->y - cp->e[1].v1->y,cp->e[1].v2->z - cp->e[1].v1->z);

		t_Normal = MWCrossProduct(&Edge1, &Edge2);
		t_Normal.MakeUnit();
		
		//*** Cosine shading based on the surface normal, clamped to [0, 1]
		float Shade = MWDotProduct(&t_Normal, &game.display.light_source_direction);
		
		if (Shade < 0.0) Shade = 0.0;
		if (Shade > 1.0) Shade = 1.0;

		t_Shade = (Shade * 255.0) + (AmbientLight * 255.0);
		if (t_Shade < 0) t_Shade = 0;
		if (t_Shade > 255.0) t_Shade = 255.0;

//assign the shade of light to these polygons...
		cp->vv[0]->r = cp->vv[0]->g = cp->vv[0]->b = t_Shade;
		cp->vv[1]->r = cp->vv[1]->g = cp->vv[1]->b = t_Shade;
		cp->vv[2]->r = cp->vv[2]->g = cp->vv[2]->b = t_Shade;

		cp = cp->pnext;

	} while(1);*/
}

//#####################################################################################################################################################################
